# -*- coding: ascii -*-

import sys
import urllib
from xml.dom import minidom, Node
import smb
from socket import *
import SocketServer
import thread
import struct
import xbmc

# TODO
#  Handle disconnect
#		Start thread for each connection
#		If a thread is started for consecutive connections, stop previous connection and thread

MYVIDEOS = 0x00
MYMUSIC = 0x01
MYPICTURES = 0x02

DEBUG = 0
RUNONPC = 0

	
def validip(ip):
    try:
        q = ip.split('.')
        if len(q) != 4: return False
        for n in q:
            if int(n) > 255: return False
        return True 
    except:
        return False
    

class smbbrowser:
	def __init__(self,url):	      
		self.protocol = ''
		self.ip = ''
		self.ntdomain = ''
		self.user = ''
		self.password = ''
		self.share = ''
		self.path = ''
		self.initialpath = ''
	
		if url.count('://'):
			self.protocol, url = url.split('://',1)      	
			
			if self.protocol == 'smb':
				if url.count(';'):
					self.ntdomain, url = url.split(';',1)

				if url.count('@'):
					userpass, url = url.split('@',1)
				else:
					self.user = ''
					self.password = ''

				if userpass.count(':'):
					self.user, self.password = userpass.split(':')

				if url.count('/'):
					self.ip, self.path = url.split('/',1)

					if self.path.count('/'):
						self.share, self.path = self.path.split('/',1)
					else:
						self.share = self.path
						self.path = ''
				else:
					self.path = '/'

				self.initialpath = self.path
		
		if DEBUG == 1:
			print 'protocol: ' + self.protocol
			print 'ip:       ' + self.ip
			print 'ntdomain: ' + self.ntdomain
			print 'user:     ' + self.user
			print 'password: ' + self.password
			print 'share:    ' + self.share
			print 'path:     ' + self.path
      				
	def login(self):
		if not(validip(self.ip)):
			netbios = nmb.NetBIOS()
			addrs = netbios.gethostbyname(self.ip)
			self.ip = addrs[0].get_ip()
			
		self.remote = smb.SMB(self.ntdomain, self.ip)
			
		if self.remote.is_login_required():
			self.remote.login(self.user, self.password)
			
	def ls(self, path=None):		
		if not path: 
			path = self.path
					
		dirs = []
		files = []
		
		if self.share == '':
			devices = self.remote.list_shared()
			for dev in devices:				
				if dev.get_type() == smb.SHARED_DISK:
					name = dev.get_name()
		else:
			try:
				l = self.remote.list_path(self.share, self.path + '/*', self.password)		# The smb connection seems to time out on xbmc
			except:
				del self.remote

				self.remote = smb.SMB(self.ntdomain, self.ip)

				if self.remote.is_login_required():
					self.remote.login(self.user, self.password)

				l = self.remote.list_path(self.share, self.path + '/*', self.password)
			for item in l:
				itemname = item.get_longname()
				if itemname != '.' and itemname != '..':
					if item.is_directory():
						dirs.append(itemname)
					else:	
						files.append(itemname)
						
		return dirs, files
						
	def cd(self, path):
		if not self.share:
			if path == '..': return True
			self.share = path
			self.path = '/'
			return True
		if path == '..':
			if self.path == self.initialpath:
				return False
			if self.path == '/':
				self.share = ''
				return True
			new_path = '/'.join(self.path.split('/')[0:-1])
			if not new_path: new_path = '/'
		else:
			if self.path == '/':
				new_path = '/' + path
			else:
				new_path = self.path + '/' + path
		self.path = new_path
		return True
		
	def getfile(self, filename):
		print 'smb://' + self.ntdomain + ';' + self.user + ':' + self.password + '@' + self.ip + '/' + self.share + '/' +  self.path + '/' + filename
		return 'smb://' + self.ntdomain + ';' + self.user + ':' + self.password + '@' + self.ip + '/' + self.share + '/' +  self.path + '/' + filename
		
class xbmcbrowser:

	def __init__(self):
		self.browsemode = MYVIDEOS
		self.path = ['/', '/', '/']
		self.root = [{}, {}, {}]
		self.samba = [None, None, None]
		self.extensions = [[], [], []]
	
		configfile = open('q:\XboxMediaCenter.xml', 'r')
		xmlsource = configfile.read()		
		
		root = minidom.parseString(xmlsource)
		node = root.firstChild
		
		if node.nodeName == "xboxmediacenter":
			for child in node.childNodes:
				if child.nodeType == Node.ELEMENT_NODE:
					if child.nodeName == "pictureextensions":
						self.extensions[MYPICTURES] = child.firstChild.nodeValue.split("|")
					if child.nodeName == "musicextensions":
						self.extensions[MYMUSIC] = child.firstChild.nodeValue.split("|")
					if child.nodeName == "videoextensions":
						self.extensions[MYVIDEOS] = child.firstChild.nodeValue.split("|")
					if child.nodeName == "video":
						self.root[MYVIDEOS] = self.process(child.firstChild)
					if child.nodeName == "music":
						self.root[MYMUSIC] = self.process(child.firstChild)
					if child.nodeName == "pictures":
						self.root[MYPICTURES] = self.process(child.firstChild)

	def process(self, node):		
		shares = []
		while node != None:			
			if node.nodeType == Node.ELEMENT_NODE:
				if node.nodeName == "bookmark":
					for child in node.childNodes:
						if child.nodeType == Node.ELEMENT_NODE:
							if child.nodeName == "name":
								name = child.firstChild.nodeValue
							if child.nodeName == "path":
								path = child.firstChild.nodeValue
					shares.append((name, path))
			node = node.nextSibling
		return dict(shares)
		
	def switch(self, mode):
		self.browsemode = mode
			
	def ls(self):
		if self.path[self.browsemode] == '/':
			d = []
			for key in self.root[self.browsemode]:
				d.append(key)

			return d, []
		else:
			s = self.samba[self.browsemode]
			f = []
			d, fx = s.ls()
			
			for file in fx:
				tail = file[file.rfind('.'):]
				if self.extensions[self.browsemode].count(tail) > 0:
					f.append(file)

			d.sort() # key=str.lower)
			f.sort() # key=str.lower)
			
			return d, f
			
	def play(self, filename):
		s = self.samba[self.browsemode]
		if RUNONPC == 0:
			xbmc.Player().play(s.getfile(filename))		
		else:
			print s.getfile(filename)

	def cd(self, path):
		# trim leading and trailing /
		
		if path == '..':
			if self.path[self.browsemode] == '/': return
			
			s = self.samba[self.browsemode]
			if not s.cd(path):
				del s
				self.path[self.browsemode] = '/'
			else:
				print 'TODO: Strip last folder'
		else:
			if self.path[self.browsemode] == '/':
				
				if self.root[self.browsemode].has_key(path):
					share = self.root[self.browsemode][path].encode('ascii')

					s = smbbrowser(share)
					s.login()

					self.path[self.browsemode] += path
					self.samba[self.browsemode] = s

				else:
					print 'Invalid directory'
			else:
				s = self.samba[self.browsemode]
				s.cd(path)		## TODO: samba cd must check valid path
				
	def cmd(self, command):
		if RUNONPC == 1:
			print 'Command ' + command
		else:
			if command=='pause':
				xbmc.Player().pause()
			if command=='stop':
				xbmc.Player().stop()
			if command=='play':
				xbmc.Player().play()
			if command=='prev':
				xbmc.Player().playprevious()
			if command=='next':
				xbmc.Player().playnext()

class xbmcsrv:

	def __init__(self, host, port):
		self.addr = (host, port)
		self.buf = 1024
		self.xbmcbrw = xbmcbrowser()
		self.open_connections = {}
		
	def send(self, connection, data):
		print len(data)
		connection.sendall(struct.pack('>i', len(data)) + data)
		
	def connect(self, connection, address):
		while 1:
			try:
				s = connection.recvfrom(self.buf)[0]
			except:
				print 'Klikk'
				break;
			if s != '':
				print s
				if s == 'ls':
					dirs, files = self.xbmcbrw.ls()
					data = ''.join(['D' + dir + '\n' for dir in dirs])
					data += ''.join(['F' + file + '\n' for file in files])
					self.send(connection, data)
				if s[:4] == 'play':
					filename = s[5:]					
					self.xbmcbrw.play(filename)
					self.send(connection, '003 PLAYING FILE')
				if s[:4] == 'mode':
					mode = s[5:]
					if mode == "video":
						self.xbmcbrw.switch(MYVIDEOS)
						self.send(connection, '001 MODE SWITCHED')
					elif mode == "music":
						self.xbmcbrw.switch(MYMUSIC)
						self.send(connection, '001 MODE SWITCHED')
					elif mode == "pictures":
						self.xbmcbrw.switch(MYPICTURES)
						self.send(connection, '001 MODE SWITCHED')
					else:
						self.send(connection, '100 UNKNOWN MODE')
				if s[:2] == 'cd':
					path = s[3:]
					self.xbmcbrw.cd(path)
					self.send(connection, '002 DIRECTORY CHANGED')
				if s[:3] == 'cmd':
					command = s[4:]
					self.xbmcbrw.cmd(command)
					self.send(connection, '003 COMMAND EXECUTED')
				if s == 'quit':
					self.send(connection, 'quitting')
					break
					
		connection.close()

	def start(self):
		sock = socket(AF_INET,SOCK_STREAM)
		sock.bind(self.addr)
		sock.listen(5)
		
		while 1:
			print 'Awaiting connection'
			connection, address = sock.accept()
			print 'Client Connected'
			
			for con in self.open_connections:
				self.open_connections[con].close()
				
			self.open_connections[address] = connection
			
			thread.start_new_thread(self.connect, (connection, address))
				

def main():
	s = xbmcsrv('', 1337)
	s.start()

if __name__ == "__main__" and RUNONPC == 1:
	main()
else:
	main()